"use strict";

require("core-js/modules/es.symbol.description");

require("core-js/modules/es.array.concat");

require("core-js/modules/es.array.filter");

require("core-js/modules/es.array.flat");

require("core-js/modules/es.array.includes");

require("core-js/modules/es.array.iterator");

require("core-js/modules/es.array.map");

require("core-js/modules/es.array.slice");

require("core-js/modules/es.array.splice");

require("core-js/modules/es.array.unscopables.flat");

require("core-js/modules/es.object.entries");

require("core-js/modules/es.object.values");

require("core-js/modules/es.promise");

require("core-js/modules/es.string.match");

require("core-js/modules/es.string.replace");

require("core-js/modules/es.string.split");

require("core-js/modules/es.string.trim");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.MySQL = exports.PostgreSQL = exports.FxSQL_DEBUG = void 0;

var _fxjs = require("fxjs");

var _pg = _interopRequireDefault(require("pg"));

var _mysql = _interopRequireDefault(require("mysql"));

var _pluralize = _interopRequireDefault(require("pluralize"));

var _ljoin = _interopRequireDefault(require("./ljoin.js"));

var _dumper = _interopRequireDefault(require("dumper.js"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

const dump = _dumper.default.dump;
const plural = _pluralize.default.plural,
      singular = _pluralize.default.singular;
const FxSQL_DEBUG = {
  DUMP: false,
  LOG: false,
  ERROR_WITH_SQL: false
};
exports.FxSQL_DEBUG = FxSQL_DEBUG;
const SymbolColumn = Symbol('COLUMN');
const SymbolTag = Symbol('TAG');
const SymbolInjection = Symbol('INJECTION');
const SymbolDefault = Symbol('DEFAULT');

const wrap_arr = a => Array.isArray(a) ? a : [a];

const mix = (arr1, arr2) => arr1.reduce((res, item, i) => {
  res.push(item);
  i < arr2.length && res.push(arr2[i]);
  return res;
}, []);

const uniq_index_by = (0, _fxjs.curry)((f, coll) => (0, _fxjs.index_by)(f, (0, _fxjs.unique_by)(f, coll)));

const first = a => a && a[0];

const last = a => a && a[a.length - 1];

const is_plain_object = obj => !!obj && typeof obj == 'object' && obj.constructor == Object;

const is_column = f => !!(f && f[SymbolColumn]);

const is_tag = f => !!(f && f[SymbolTag]);

const is_injection = query => query == SymbolInjection;

const tag = f => typeof f == 'function' ? Object.assign(f, {
  [SymbolTag]: true
}) : tag(_ => f);

function BASE({
  create_pool,
  end_pool,
  query_fn,
  get_connection = pool => pool.connect(),
  BEGIN = client => client.query('BEGIN'),
  COMMIT: _COMMIT =
  /*#__PURE__*/
  function () {
    var _ref = _asyncToGenerator(function* (client) {
      yield client.query('COMMIT');
      return yield client.release();
    });

    return function (_x) {
      return _ref.apply(this, arguments);
    };
  }(),
  ROLLBACK: _ROLLBACK =
  /*#__PURE__*/
  function () {
    var _ref2 = _asyncToGenerator(function* (client) {
      yield client.query('ROLLBACK');
      return yield client.release();
    });

    return function (_x2) {
      return _ref2.apply(this, arguments);
    };
  }(),
  reg_q = /\?\?/g,
  to_q = () => '??',
  escape_dq = idtf => `"${('' + idtf).replace(/\\/g, '\\\\').replace(/"/g, '""')}"`,
  replace_q = query => {
    if (is_injection(query)) return SymbolInjection;
    let i = 0;
    query.text = query.text.replace(reg_q, _ => `$${++i}`);
    return query;
  },
  use_ljoin
}) {
  const add_column = me => me.column == '*' ? COLUMN(me.as + '.*') : is_column(me.column) ? COLUMN(...(0, _fxjs.go)(me.column.originals.concat((0, _fxjs.pluck)('left_key', me.rels)), (0, _fxjs.map)(c => (0, _fxjs.is_string)(c) ? me.as + '.' + c : c), _fxjs.uniq)) : is_tag(me.column) ? CL(me.column) : tag(SymbolInjection);

  const columnize = v => v == '*' ? '*' : v.match(/\s*\sas\s\s*/i) ? v.split(/\s*\sas\s\s*/i).map(dq).join(' AS ') : dq(v);

  const dq = str => ('' + str).split('.').map(s => s == '*' ? s : escape_dq(s)).join('.');

  function ASSOCIATE_MODULE(strs, ...tails) {
    strs = strs.slice();
    strs.push(strs.pop() + '\n');

    var _import_module = import_module(strs, tails),
        _import_module2 = _slicedToArray(_import_module, 2),
        strs2 = _import_module2[0],
        tails2 = _import_module2[1];

    const splited = (0, _fxjs.deep_flat)(strs.map(str => str.split('\n'))).filter(str => str.match(/^\s*/)[0]).filter(str => str.trim());
    const min = (0, _fxjs.min_by)(str => str.match(/^\s*/)[0].length, splited) || '';
    const a = '\n' + min.match(/^\s*/)[0];
    return [strs2.map(str => str.split(a).join('\n')), tails2];
  }

  function import_module(strs, tails) {
    if (!tails.some(tail => typeof tail == 'function' && !is_tag(tail))) return [strs, tails];
    var strs2 = [...strs];
    var j = 0;
    var tails2 = tails.map(function (tail, i) {
      if (typeof tail != 'function' || is_tag(tail)) return tail;
      var k = i + j++;
      var spaces = last(strs2[k].split('\n')).match(/^\s*/)[0];

      var _tail = tail(),
          _tail2 = _slicedToArray(_tail, 2),
          strs3 = _tail2[0],
          tails3 = _tail2[1];

      strs2.splice(k + 1, 0, strs3.map(str => str.replace(/\n/g, '\n' + spaces)));
      return tails3;
    });
    return [(0, _fxjs.deep_flat)(strs2).filter(str => str.trim()).reduce((strs, str, i) => {
      if (i == 0) return strs.push(str), strs;
      const splited = last(strs).split('\n');

      if (!last(splited).trim()) {
        splited[splited.length - 1] = str.substr(1);
        strs[strs.length - 1] = splited.join('\n');
      } else {
        strs.push(str);
      }

      return strs;
    }, []), (0, _fxjs.deep_flat)(tails2)];
  }

  function ready_sqls(strs, tails) {
    const _import_module3 = import_module(strs, tails),
          _import_module4 = _slicedToArray(_import_module3, 2),
          strs2 = _import_module4[0],
          tails2 = _import_module4[1];

    const options = strs2.map(s => s.replace(/\s*\n/, '').split('\n').map(s => {
      var depth = s.match(/^\s*/)[0].length,
          as = s.trim(),
          rel_type;
      var prefix = as.substr(0, 2);

      if (['- ', '< ', 'x '].includes(prefix)) {
        rel_type = prefix.trim();
        as = as.substr(1).trim();
        return {
          depth,
          as,
          rel_type
        };
      } else if (prefix == 'p ') {
        rel_type = as[2];
        as = as.substr(3).trim();
        return {
          depth,
          as,
          rel_type,
          is_poly: true
        };
      } else {
        return {
          depth,
          as
        };
      }
    }));
    (0, _fxjs.go)(tails2, (0, _fxjs.map)(tail => is_tag(tail) ? {
      query: tail
    } : Object.assign({}, tail, {
      query: tail.query || tag()
    })), Object.entries, (0, _fxjs.each)(([i, t]) => (0, _fxjs.go)(options[i], last, _ => Object.assign(_, t))));
    return options;
  }

  function merge_query(queries, sep = ' ') {
    if (queries.find(is_injection)) return SymbolInjection;
    var query = (0, _fxjs.reduce)((res, query) => {
      if (!query) return res;
      if (query.text) res.text += sep + query.text;
      if (query.values) res.values.push(...query.values);
      return res;
    }, {
      text: '',
      values: []
    }, queries);
    query.text = query.text.replace(/\n/g, ' ').replace(/\s\s*/g, ' ').trim();
    return query;
  }

  function VALUES(values) {
    return tag(function () {
      values = Array.isArray(values) ? values : [values];
      const columns = (0, _fxjs.go)(values, (0, _fxjs.map)(Object.keys), _fxjs.flat, _fxjs.uniq);
      const DEFAULTS = (0, _fxjs.go)(columns, (0, _fxjs.map)(k => [k, SymbolDefault]), _fxjs.object);
      values = values.map(v => Object.assign({}, DEFAULTS, v)).map(v => Object.values(v));
      return {
        text: `(${COLUMN(...columns)().text}) VALUES (${values.map(v => v.map(v => v == SymbolDefault ? 'DEFAULT' : to_q()).join(', ')).join('), (')})`,
        values: (0, _fxjs.flat)(values.map(v => v.filter(v => v != SymbolDefault)))
      };
    });
  }

  function COLUMN(...originals) {
    return Object.assign(tag(function () {
      let sqls = (0, _fxjs.flat)(originals.map(v => (0, _fxjs.is_string)(v) ? [{
        text: columnize(v)
      }, {
        text: ', '
      }] : is_tag(v) ? [v(), {
        text: ', '
      }] : [{
        text: Object.entries(v).map(v => v.map(dq).join(' AS ')).join(', ')
      }, {
        text: ', '
      }]));
      sqls.pop();
      return merge_query(sqls, '');
    }), {
      [SymbolColumn]: true,
      originals: originals
    });
  }

  const CL = COLUMN,
        TABLE = COLUMN,
        TB = TABLE;

  function PARAMS(obj, sep) {
    return tag(function () {
      let i = 0;
      const text = Object.keys(obj).map(k => `${columnize(k)} = ${to_q()}`).join(sep);
      const values = Object.values(obj);
      return {
        text: text.replace(reg_q, function () {
          const value = values[i++];
          return is_column(value) ? value().text : to_q();
        }),
        values: (0, _fxjs.reject)(is_column, values)
      };
    });
  }

  function EQ(obj, sep = 'AND') {
    return PARAMS(obj, ' ' + sep + ' ');
  }

  function SET(obj) {
    return tag(function () {
      const query = PARAMS(obj, ', ')();
      query.text = 'SET ' + query.text;
      return query;
    });
  }

  function BASE_IN(key, operator, values) {
    values = (0, _fxjs.uniq)(values);
    var keys_text = COLUMN(...wrap_arr(key))().text;
    return {
      text: `${Array.isArray(key) ? `(${keys_text})` : keys_text} ${operator} (${values.map(Array.isArray(key) ? v => `(${v.map(to_q).join(', ')})` : to_q).join(', ')})`,
      values: (0, _fxjs.deep_flat)(values)
    };
  }

  function IN(key, values) {
    return tag(function () {
      if (!values || !values.length) return {
        text: `1=??`,
        values: [0]
      };
      return BASE_IN(key, 'IN', values);
    });
  }

  function NOT_IN(key, values) {
    return tag(function () {
      if (!values || !values.length) return {
        text: `1=??`,
        values: [0]
      };
      return BASE_IN(key, 'NOT IN', values);
    });
  }

  function _SQL(texts, values) {
    return (0, _fxjs.go)(mix(texts.map(text => ({
      text
    })), values.map(value => is_tag(value) ? value() : (0, _fxjs.is_function)(value) ? SymbolInjection : {
      text: to_q(),
      values: [value]
    })), merge_query);
  }

  function SQL(texts, ...values) {
    return tag(function () {
      return _SQL(texts, values);
    });
  }

  function SQLS(sqls) {
    return tag(function () {
      return sqls.find(sql => !is_tag(sql)) ? SymbolInjection : merge_query(sqls.map(sql => sql()));
    });
  }

  function baseAssociate(QUERY) {
    return (
      /*#__PURE__*/
      function () {
        var _ref3 = _asyncToGenerator(function* (strs, ...tails) {
          return (0, _fxjs.go)(ready_sqls(strs, tails), _fxjs.deep_flat, (0, _fxjs.filter)(t => t.as), (0, _fxjs.each)(option => {
            option.column = option.column || '*';
            option.join = option.join || SQL``;
            option.query = option.query || tag();
            option.table = option.table || (option.rel_type == '-' ? plural(option.as) : option.as);
            option.rels = [];
            option.row_number = option.row_number || [];
          }), function setting([left, ...rest]) {
            const cur = [left];
            (0, _fxjs.each)(me => {
              while (!(last(cur).depth < me.depth)) cur.pop();

              const left = last(cur);
              left.rels.push(me);

              if (me.rel_type == '-') {
                me.left_key = me.left_key || (me.is_poly ? 'id' : singular(me.table) + '_id');
                me.where_key = me.key || (me.is_poly ? 'attached_id' : 'id');
                me.xjoin = tag();
              } else if (me.rel_type == '<') {
                me.left_key = me.left_key || 'id';
                me.where_key = me.key || (me.is_poly ? 'attached_id' : singular(left.table) + '_id');
                me.xjoin = tag();
              } else if (me.rel_type == 'x') {
                me.left_key = me.left_key || 'id';
                const xtable = me.xtable || left.table + '_' + me.table;
                const xtable_as = me.xtable_as || xtable;
                me.where_key = `${xtable_as}.${me.left_xkey || singular(left.table) + '_id'}`;
                me.xjoin = SQL`INNER JOIN ${TB(xtable)} AS ${TB(xtable_as)} ON ${EQ({
                  [`${xtable_as}.${me.xkey || singular(me.table) + '_id'}`]: COLUMN(me.as + '.' + (me.key || 'id'))
                })}`;
              }

              me.poly_type = me.is_poly ? SQL`AND ${EQ(is_plain_object(me.poly_type) ? me.poly_type : {
                attached_type: me.poly_type || left.table
              })}` : tag();
              cur.push(me);
            }, rest);
            return left;
          },
          /*#__PURE__*/
          function () {
            var _ref4 = _asyncToGenerator(function* (me) {
              const lefts = yield QUERY`
            SELECT ${add_column(me)}
              FROM ${TB(me.table)} AS ${TB(me.as)} ${me.query}`;
              return (0, _fxjs.go)([lefts, me], function recur([lefts, option]) {
                return lefts.length && option.rels.length && (0, _fxjs.go)(option.rels, _fxjs.C.map(
                /*#__PURE__*/
                function () {
                  var _ref5 = _asyncToGenerator(function* (me) {
                    const query = me.query();
                    if (query && query.text) query.text = query.text.replace(/^\s*WHERE/i, 'AND');
                    var fold_key = me.rel_type == 'x' ? `_#_${me.where_key.split('.')[1]}_#_` : me.where_key;
                    const colums = (0, _fxjs.uniq)(add_column(me).originals.concat(me.rel_type != 'x' ? me.as + '.' + me.where_key : me.where_key + ' AS ' + fold_key));
                    const in_vals = (0, _fxjs.filter)(a => a != null, (0, _fxjs.pluck)(me.left_key, lefts));
                    const is_row_num = me.row_number.length == 2;
                    const rights = !in_vals.length ? [] : yield is_row_num ? QUERY`
                  SELECT *
                  FROM (
                    SELECT
                      ${COLUMN(...colums)}, 
                      ROW_NUMBER() OVER (PARTITION BY ${CL(me.where_key)} ORDER BY ${me.row_number[1]}) as "--row_number--"
                    FROM ${TB(me.table)} AS ${TB(me.as)}
                    ${me.join} 
                    ${me.xjoin} 
                    WHERE ${IN(me.as + '.' + me.where_key, in_vals)} ${me.poly_type} ${tag(query)}
                  ) AS "--row_number_table--"
                  WHERE "--row_number_table--"."--row_number--"<=${me.row_number[0]}` : QUERY`
                  SELECT ${COLUMN(...colums)}
                    FROM ${TB(me.table)} AS ${TB(me.as)}
                    ${me.join} 
                    ${me.xjoin} 
                    WHERE ${IN(me.as + '.' + me.where_key, in_vals)} ${me.poly_type} ${tag(query)}`;

                    const _ref6 = me.rel_type == '-' ? [uniq_index_by, () => ({})] : [_fxjs.group_by, () => []],
                          _ref7 = _slicedToArray(_ref6, 2),
                          folder = _ref7[0],
                          default_value = _ref7[1];

                    return (0, _fxjs.go)(rights, is_row_num ? (0, _fxjs.map)(r => delete r['--row_number--'] && r) : r => r, folder(a => a[fold_key]), folded => (0, _fxjs.each)(function (left) {
                      left._ = left._ || {};
                      left._[me.as] = folded[left[me.left_key]] || default_value();
                      if (me.rel_type == 'x') (0, _fxjs.each)(a => delete a[fold_key], left._[me.as]);
                    }, lefts), _ => recur([rights, me]), _ => me.hook && (0, _fxjs.each)(left => (0, _fxjs.go)(me.hook(left._[me.as]), right => left._[me.as] = right), lefts));
                  });

                  return function (_x5) {
                    return _ref5.apply(this, arguments);
                  };
                }()));
              }, _ => me.hook ? me.hook(lefts) : lefts);
            });

            return function (_x4) {
              return _ref4.apply(this, arguments);
            };
          }());
        });

        return function (_x3) {
          return _ref3.apply(this, arguments);
        };
      }()
    );
  }

  function CONNECT(connection_info) {
    const pool = create_pool(connection_info);
    const pool_query = query_fn(pool);
    const _on2_obj = {
      error: function error() {}
    };

    pool.queryError = cb => {
      _on2_obj['error'] = cb;
    };

    function base_query(_x6, _x7, _x8, _x9) {
      return _base_query.apply(this, arguments);
    }

    function _base_query() {
      _base_query = _asyncToGenerator(function* (excute_query, texts, values, transaction_querys) {
        const error_for_stack = new Error();

        try {
          var query = replace_q(_SQL(texts, values));
          if (Array.isArray(transaction_querys)) transaction_querys.push({
            text: query.text,
            values: JSON.stringify(query.values),
            stack: new Error().stack
          });
          return yield (0, _fxjs.go)(is_injection(query) ? Promise.reject('INJECTION ERROR') : query, (0, _fxjs.tap)(function (query) {
            if (FxSQL_DEBUG.DUMP) dump(query);
            typeof FxSQL_DEBUG.LOG == 'function' ? FxSQL_DEBUG.LOG(query) : FxSQL_DEBUG.LOG && console.log(query.text, '\n', query.values);
          }), excute_query);
        } catch (e) {
          FxSQL_DEBUG.ERROR_WITH_SQL && (e.stack = `\nFxSQL_DEBUG.ERROR_WITH_SQL:\n  text: ${query.text}\n  values: ${JSON.stringify(query.values)}\n${e.stack}`);
          error_for_stack.message = e.message;

          _on2_obj.error(query, error_for_stack);

          throw e;
        }
      });
      return _base_query.apply(this, arguments);
    }

    function QUERY(texts, ...values) {
      return base_query(pool_query, texts, values);
    }

    function END() {
      return end_pool(pool);
    }

    const QUERY1 = (0, _fxjs.pipe)(QUERY, first),
          ASSOCIATE = baseAssociate(QUERY),
          ASSOCIATE1 = (0, _fxjs.pipe)(ASSOCIATE, first);
    var ljoin = null;

    function LOAD_LJOIN(_x10) {
      return _LOAD_LJOIN.apply(this, arguments);
    }

    function _LOAD_LJOIN() {
      _LOAD_LJOIN = _asyncToGenerator(function* (QUERY) {
        if (!ljoin) ljoin = yield (0, _ljoin.default)({
          ready_sqls,
          add_column,
          tag,
          FxSQL_DEBUG,
          connection_info,
          QUERY,
          VALUES,
          IN,
          NOT_IN,
          EQ,
          SET,
          COLUMN,
          CL,
          TABLE,
          TB,
          SQL,
          SQLS
        });
        return ljoin(QUERY);
      });
      return _LOAD_LJOIN.apply(this, arguments);
    }

    let baseTransactionQuery = function baseTransactionQuery() {};

    let transactionErrorHandler = function transactionErrorHandler(err) {
      throw err;
    };

    return {
      POOL: pool,
      VALUES,
      IN,
      NOT_IN,
      EQ,
      SET,
      COLUMN,
      CL,
      TABLE,
      TB,
      SQL,
      SQLS,
      FxSQL_DEBUG,
      QUERY,
      QUERY1,
      ASSOCIATE,
      ASSOCIATE1,
      ASSOCIATE_MODULE,
      END,
      LOAD_LJOIN: use_ljoin ? LOAD_LJOIN : null,
      config: {
        setBaseTransactionQuery(func) {
          baseTransactionQuery = func;
        },

        setTransactionErrorHandler(func) {
          transactionErrorHandler = func;
        }

      },

      TRANSACTION() {
        return _asyncToGenerator(function* () {
          const stack = Error('Transaction start stacktrace');

          try {
            const client = yield get_connection(pool);
            const client_query = query_fn(client);
            const transaction_querys = [];
            yield BEGIN(client);

            const QUERY = function QUERY(texts, ...values) {
              return base_query(client_query, texts, values, transaction_querys);
            };

            const QUERY1 = (0, _fxjs.pipe)(QUERY, first),
                  ASSOCIATE = baseAssociate(QUERY),
                  ASSOCIATE1 = (0, _fxjs.pipe)(ASSOCIATE, first);
            yield baseTransactionQuery(QUERY, QUERY1);
            client.on('error', err => {
              transactionErrorHandler(err, client, transaction_querys, stack);
            });
            return {
              client,
              VALUES,
              IN,
              NOT_IN,
              EQ,
              SET,
              COLUMN,
              CL,
              TABLE,
              TB,
              SQL,
              QUERY,
              QUERY1,
              ASSOCIATE,
              ASSOCIATE1,
              LJOIN: use_ljoin && ljoin ? yield ljoin(QUERY) : null,
              COMMIT: _ => {
                const _ref8 = new Error(),
                      stack = _ref8.stack;

                transaction_querys.push({
                  query: 'COMMIT',
                  VALUES: [],
                  stack
                });
                return _COMMIT(client);
              },
              ROLLBACK: _ => {
                const _ref9 = new Error(),
                      stack = _ref9.stack;

                transaction_querys.push({
                  query: 'ROLLBACK',
                  VALUES: [],
                  stack
                });
                return _ROLLBACK(client);
              }
            };
          } catch (e) {
            throw e;
          }
        })();
      }

    };
  }

  return {
    CONNECT,
    VALUES,
    IN,
    NOT_IN,
    EQ,
    SET,
    COLUMN,
    CL,
    TABLE,
    TB,
    SQL,
    SQLS,
    FxSQL_DEBUG
  };
}

const method_promise = (0, _fxjs.curry)((name, obj) => new Promise((resolve, reject) => obj[name]((err, res) => err ? reject(err) : resolve(res))));
const PostgreSQL = BASE({
  create_pool: connection_info => new _pg.default.Pool(connection_info),
  end_pool: pool => pool.end(),
  query_fn: pool => (0, _fxjs.pipe)(pool.query.bind(pool), res => res.rows),
  use_ljoin: true
}),
      MySQL = BASE({
  create_pool: connection_info => _mysql.default.createPool(connection_info),
  end_pool: pool => new Promise((resolve, reject) => pool.end(err => err ? reject(err) : resolve())),
  query_fn: pool => ({
    text,
    values
  }) => new Promise((resolve, reject) => pool.query(text, values, (err, results) => err ? reject(err) : resolve(results))),
  get_connection: method_promise('getConnection'),
  BEGIN: method_promise('beginTransaction'),
  COMMIT: method_promise('commit'),
  ROLLBACK: method_promise('rollback'),
  reg_q: /\?/g,
  to_q: () => '?',
  escape_dq: _mysql.default.escapeId,
  replace_q: _ => _
});
exports.MySQL = MySQL;
exports.PostgreSQL = PostgreSQL;